VERSION 5.00
Begin VB.Form frmMarquee 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   ClientHeight    =   690
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3540
   ControlBox      =   0   'False
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   690
   ScaleWidth      =   3540
   ShowInTaskbar   =   0   'False
   Begin VB.Timer ScrollTimer 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   480
      Top             =   0
   End
   Begin VB.PictureBox pbScrollBox 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   48
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   0
      ScaleHeight     =   49
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   241
      TabIndex        =   0
      Top             =   0
      Width           =   3615
      Begin VB.Label text 
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   48
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000008&
         Height          =   600
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Visible         =   0   'False
         Width           =   150
      End
   End
End
Attribute VB_Name = "frmMarquee"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const HWND_TOPMOST As Integer = -1
Private Const SWP_NOMOVE As Long = &H2
Private Const SWP_NOSIZE  As Long = &H1
Private Const RC_PALETTE As Long = &H100
Private Const SIZEPALETTE As Long = 104
Private Const RASTERCAPS As Long = 38

Private m_cM As New cMonitors
Private TheX As Long

Private Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type

Private Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY ' Enough for 256 colors
End Type

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Private Type PicBmp
    Size As Long
Type As Long '<:-):SUGGESTION: Legal but ill-advised to use VB Reserved words as Variable names
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

Private marqueeWidth As Long
Private m_cCyloid As New cCyloid

Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal iCapabilitiy As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hDC As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function SelectPalette Lib "gdi32" (ByVal hDC As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Private Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture
    Dim r As Long
    Dim Pic As PicBmp
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID

    'Fill GUID info
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With 'IID_IDISPATCH
    
    'Fill picture info
    With Pic
        .Size = Len(Pic) ' Length of structure
        .Type = vbPicTypeBitmap ' Type of Picture (bitmap)
        .hBmp = hBmp ' Handle to bitmap
        .hPal = hPal ' Handle to palette (may be null)
    End With 'PIC
    
    'Create the picture
    r = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
    
    'Return the new picture
    Set CreateBitmapPicture = IPic
End Function

Private Sub Form_Click()
    'Unload if user clicks on OSD
    ' Unload Me
End Sub

Public Sub Form_Load()
    'Make Our form Top-Most
    SetWindowPos Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
    m_cCyloid.setCyloid 2, 1, 10, 1, 2
End Sub

Public Function setSize()
    Dim topOffset As Integer
    Dim MyMonitor As cMonitor
   
    Set MyMonitor = m_cM.Monitor(frmScroller.cboMonitors.ItemData(frmScroller.cboMonitors.ListIndex))
      
    topOffset = Int((frmScroller.vsbPosition.Value / frmScroller.vsbPosition.Max) * MyMonitor.Height)
    If (topOffset + pbScrollBox.TextHeight("TEXT") > MyMonitor.Height) Then
        topOffset = MyMonitor.Height - pbScrollBox.TextHeight("TEXT")
    End If
    
    ' move to the newly selected monitor
    Me.Move Me.ScaleX(MyMonitor.Left, vbPixels, vbTwips), Me.ScaleY(MyMonitor.Top + topOffset, vbPixels, vbTwips)

    Me.Width = Me.ScaleX(MyMonitor.Width, vbPixels, Me.ScaleMode)
    Me.Height = Me.ScaleY(pbScrollBox.TextHeight("TEXT"), vbPoints, Me.ScaleMode)
    
    pbScrollBox.Width = Me.ScaleX(MyMonitor.Width, vbPixels, Me.ScaleMode)
    text.Width = Me.ScaleX(MyMonitor.Width, vbPixels, Me.ScaleMode)
    Me.pbScrollBox.Height = Me.ScaleY(pbScrollBox.TextHeight("TEXT"), vbPoints, Me.ScaleMode)
    
    marqueeWidth = pbScrollBox.TextWidth(text.Caption)
    
    TheX = pbScrollBox.ScaleWidth ' Set the starting point (off the right edge)

    'Enable the timer will make the animation
    'Change Timer time to make the animation fast or Slow
    ScrollTimer.Interval = 10
    ScrollTimer.Enabled = True
End Function

Public Function movePosition()
    Dim topOffset As Integer
    Dim MyMonitor As cMonitor
   
    Set MyMonitor = m_cM.Monitor(frmScroller.cboMonitors.ItemData(frmScroller.cboMonitors.ListIndex))
    
    topOffset = Int((frmScroller.vsbPosition.Value / frmScroller.vsbPosition.Max) * MyMonitor.Height)
    If (topOffset + pbScrollBox.TextHeight("TEXT") > MyMonitor.Height) Then
        topOffset = MyMonitor.Height - pbScrollBox.TextHeight("TEXT")
    End If
    
    Me.Top = Me.ScaleX(topOffset, vbPixels, Me.ScaleMode)
End Function

Public Function moveMonitor()
    Dim topOffset As Integer
    Dim MyMonitor As cMonitor
   
    Set MyMonitor = m_cM.Monitor(frmScroller.cboMonitors.ItemData(frmScroller.cboMonitors.ListIndex))

    topOffset = Int((frmScroller.vsbPosition.Value / frmScroller.vsbPosition.Max) * MyMonitor.Height)
    If (topOffset + pbScrollBox.TextHeight("TEXT") > MyMonitor.Height) Then
        topOffset = MyMonitor.Height - pbScrollBox.TextHeight("TEXT")
    End If

    Me.Move Me.ScaleX(MyMonitor.Left, vbPixels, vbTwips), Me.ScaleY(MyMonitor.Top + topOffset, vbPixels, vbTwips)
    Me.Width = Me.ScaleX(MyMonitor.Width, vbPixels, Me.ScaleMode)
    Me.Height = Me.ScaleY(pbScrollBox.TextHeight("TEXT"), vbPoints, Me.ScaleMode)
End Function

Private Function hDCToPicture(ByVal hDCSrc As Long, ByVal LeftSrc As Long, ByVal TopSrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long) As Picture
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim r As Long

    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn As Long
    Dim HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long
    Dim LogPal As LOGPALETTE
    
    'Create a compatible device context
    hDCMemory = CreateCompatibleDC(hDCSrc)
    
    'Create a compatible bitmap
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    
    'Select the compatible bitmap into our compatible device context
    hBmpPrev = SelectObject(hDCMemory, hBmp)
    
    'Raster capabilities?
    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS) ' Raster
    
    'Does our picture use a palette?
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE ' Palette
    
    'What's the size of that palette?
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE) ' Size of
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        'Set the palette version
        With LogPal
            .palVersion = &H300
            
            'Number of palette entries
            .palNumEntries = 256
            
            'Retrieve the system palette entries
            r = GetSystemPaletteEntries(hDCSrc, 0, 256, .palPalEntry(0))
            'Create the palette
        End With 'LogPal
        hPal = CreatePalette(LogPal)
        
        'Select the palette
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        
        'Realize the palette
        r = RealizePalette(hDCMemory)
    End If
    'Copy the source image to our compatible device context
    r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, LeftSrc, TopSrc, vbSrcCopy)
    
    'Restore the old bitmap
    hBmp = SelectObject(hDCMemory, hBmpPrev)
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        'Select the palette
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    'Delete our memory DC
    r = DeleteDC(hDCMemory)
    Set hDCToPicture = CreateBitmapPicture(hBmp, hPal)
End Function

Private Sub ScrollTimer_Timer()
    Dim x As Single, y As Single
    pbScrollBox.Cls
    m_cCyloid.getCyloidXY x, y
    If TheX > -marqueeWidth Then
        TheX = TheX - CInt(frmScroller.sldSpeed.Value) ' larger number means faster scrolling
    Else
        text.Caption = frmScroller.marqueeText & frmScroller.getPickup
        setSize
        ' frmScroller.SetFocus
        TheX = pbScrollBox.ScaleWidth
    End If

    pbScrollBox.CurrentX = TheX
    pbScrollBox.CurrentY = y
    pbScrollBox.Print text.Caption
End Sub

Private Sub text_Click()
    'Unload if user clicks on OSD
    ' Unload Me
End Sub

